#include <M5StickCPlus.h>
#include <WiFi.h>
#include <HTTPClient.h>
#include <time.h>

const char* ssid = "Home";
const char* password = "Smart@2018";

void setup() {
  M5.begin();
  M5.Lcd.setRotation(3);
  
  Serial.begin(115200);
  WiFi.begin(ssid, password);

  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi...");
  }

  Serial.println("Connected to WiFi");

  configTime(0, 0, "pool.ntp.org");
}

void loop() {
  time_t now = time(nullptr);
  struct tm* timeinfo = localtime(&now);

  char dateStr[16];
  strftime(dateStr, 16, "%d-%m-%Y", timeinfo);

  char timeStr[9];
  strftime(timeStr, 9, "%H:%M:%S", timeinfo);

  M5.Lcd.fillScreen(TFT_BLACK);
  M5.Lcd.setCursor(0, 0);
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_WHITE, TFT_BLACK);
  M5.Lcd.print("Date: ");
  M5.Lcd.println(dateStr);
  M5.Lcd.print("Time: ");
  M5.Lcd.println(timeStr);

  delay(1000);
}
